# -*- coding: utf-8 -*-
# Elisa - Home multimedia server
# Copyright (C) 2006,2007 Fluendo Embedded S.L. (www.fluendo.com).
# All rights reserved.
#
# This file is available under one of two license agreements.
#
# This file is licensed under the GPL version 2.
# See "LICENSE.GPL" in the root of this distribution including a special
# exception to use Elisa with Fluendo's plugins.
#
# The GPL part of Elisa is also available under a commercial licensing
# agreement from Fluendo.
# See "LICENSE.Elisa" in the root directory of this distribution package
# for details on that license.

from pgm.form import rectangle, label, color, stroke
from pgm.layout import group
from pgm import widget

class Loading(group.Group):

    def __init__(self):
        size = (800, 600)
        group.Group.__init__(self, size=size)
        self._rect = rectangle.Rectangle(size=size)
        self._rect.ordering = widget.NEAR
        #self._rect.tz = 200
        self._label = label.Label(font_size=34, size=(size[0], 40),
                                  weight=label.WEIGHT_BOLD)
        self.add(self._rect)
        self.add(self._label)
        self._label.position = (50, 250)
        self._label.ordering = widget.NEAR

        self.hide()

    def text__set(self, text):
        self._label.text = text
        if text:
            self.opacity = 150
        else:
            self.opacity = 0
            
    def text__get(self):
        return self._label.text

    def hide(self):
        self.visible = False

    def show(self):
        self.visible = True

    def visible__set(self, visible):
        group.Group.visible__set(self, visible)
        self._label.visible = visible
        self._rect.visible = visible
