# -*- coding: utf-8 -*-
# Elisa - Home multimedia server
# Copyright (C) 2006,2007 Fluendo Embedded S.L. (www.fluendo.com).
# All rights reserved.
#
# This file is available under one of two license agreements.
#
# This file is licensed under the GPL version 2.
# See "LICENSE.GPL" in the root of this distribution including a special
# exception to use Elisa with Fluendo's plugins.
#
# The GPL part of Elisa is also available under a commercial licensing
# agreement from Fluendo.
# See "LICENSE.Elisa" in the root directory of this distribution package
# for details on that license.

import unittest

from elisa.core.plugins.tests.test_elisa_plugin import TestElisaPlugin
from elisa.core.plugins.flickr import FlickrPlugin

class TestFlickrPlugin(TestElisaPlugin):
    test_plugin_class = FlickrPlugin

    def testChild1(self):
        str = self.plug.get_direct_children("flickr://tags/hamster")
        self.failUnless(str)

    def testChild2(self):
        str = self.plug.get_direct_children("flickr://search/jokosher")
        self.failUnless(str)

    def testChild3(self):
        str = self.plug.get_direct_children("flickr://user/bees")
        self.failUnless(str)

    def testChild4(self):
        str = self.plug.get_direct_children("flickr://group/56878018@N00")
        self.failUnless(str)

    def testNextLocation(self):
        str = self.plug.next_location("flickr://search/gstreamer")
        self.failUnless(str)

    
