# -*- coding: utf-8 -*-
# Elisa - Home multimedia server
# Copyright (C) 2006,2007 Fluendo Embedded S.L. (www.fluendo.com).
# All rights reserved.
#
# This file is available under one of two license agreements.
#
# This file is licensed under the GPL version 2.
# See "LICENSE.GPL" in the root of this distribution including a special
# exception to use Elisa with Fluendo's plugins.
#
# The GPL part of Elisa is also available under a commercial licensing
# agreement from Fluendo.
# See "LICENSE.Elisa" in the root directory of this distribution package
# for details on that license.

from pgm.message.signal import Signal
from elisa.core import history_item
from elisa.core.menu import MenuItem
from pgm.widget import Widget

root_menu_built = Signal('root-menu-built', (MenuItem,))
active_changed = Signal('active-changed', (MenuItem, Widget,
                                           MenuItem, Widget,
                                           unicode, int))
item_activated = Signal('item-activated', (MenuItem, Widget))
item_added = Signal('item-added', (MenuItem, int))
item_removed = Signal('item-removed', (MenuItem,))
item_bound = Signal('item-bound', (MenuItem, Widget))
item_unbound = Signal('item-unbound', (MenuItem, Widget))
level_added = Signal('level-added', (MenuItem,))
level_removed = Signal('level-removed', (MenuItem,))
level_bound = Signal('level-bound', (MenuItem, Widget,))
level_unbound = Signal('level-unbound', (MenuItem, Widget,))
level_loading = Signal('level-loading', (MenuItem,))
level_loaded = Signal('level-loaded', (MenuItem, int))
