# -*- coding: utf-8 -*-
# Elisa - Home multimedia server
# Copyright (C) 2006,2007 Fluendo Embedded S.L. (www.fluendo.com).
# All rights reserved.
#
# This file is available under one of two license agreements.
#
# This file is licensed under the GPL version 2.
# See "LICENSE.GPL" in the root of this distribution including a special
# exception to use Elisa with Fluendo's plugins.
#
# The GPL part of Elisa is also available under a commercial licensing
# agreement from Fluendo.
# See "LICENSE.Elisa" in the root directory of this distribution package
# for details on that license.

from pgm.form import rectangle, label, color, image
from pgm.layout import group
from pgm import widget
import sys, os
sys.path.insert(0, os.getcwd())
from elisa.core.widgets.button import Button
from elisa.core.widgets.list import SCROLL_NORMAL, SCROLL_MIDDLE
from elisa.core.widgets.list  import HList, VList
from elisa.core import menu
from elisa.core.signals.menu import active_changed

if __name__ == '__main__':

    from pgm import render
    from pgm.layout import window, group
    from pgm.form import rectangle, image
    import sys
    from pgm.timing import controller, modifier, keyframe
    from pgm import widget
    
    # why??
    if 'twisted.internet.reactor' in sys.modules:
        del sys.modules['twisted.internet.reactor']
    try:
        from twisted.internet import glib2reactor
        glib2reactor.install()
    except AssertionError:
        # already installed...
        pass
    
    from twisted.internet import reactor, task
    from twisted.spread import pb
    import gobject
    
    pgmrender = render.init('opengl1')            
    
    def exit_event_cb(event):    
        win.main_quit()
        reactor.stop()
                    
    title = 'List Scrollbar test'
    win = window.Window(title=title)

    base = 'elisa/core/plugins/skins/default/pictures/config/'
    button_path = os.path.join(base, 'button_select.png')
    prev_path = os.path.join(base,'arrow_up_off.png')
    next_path = os.path.join(base,'arrow_down_off.png')
    bg_path = os.path.join(base,'left.png')

    box = VList((200, 200), 20, bg_path)

    def create_button(buttons, 
                      icon_path, text="", callback=None):
        icon = image.Image(icon_path)
        button = Button(text, icon=icon, label_pos=(0, 5))
        button.set_action_callback(callback)
        return button

    def add_button(buttons,
                   icon_path, text="", callback=None):
        buttons.add(create_button(buttons,
                                  icon_path, text, callback))

    def insert_button(buttons,
                      icon_path, text="", callback=None, index=0):
        buttons.add(create_button(buttons,
                                  icon_path, text, callback),
                    index)


    prev_button = create_button(box,
                                prev_path)
    next_button = create_button(box,
                                next_path)

    #box.set_selected(2)

    visible_items = 5
    box.set_scrollbars(visible_items, prev_button, next_button, SCROLL_NORMAL)
    #box.set_scrollbars(visible_items, prev_button, next_button, SCROLL_MIDDLE)
    box.select(2)

    def button1_action():
        print "Button 1 pressed"

    def button2_action():
        print "Button 2 pressed"

    def button3_action():
        print "Button 3 pressed"

    def button4_action():
        print "Button 4 pressed"

    def button5_action():
        print "Button 5 pressed"

    def button6_action():
        print "Button 6 pressed"

    def button7_action():
        print "Button 7 pressed"

    def button8_action():
        print "Button 8 pressed"

    
    add_button(box, button_path, text="1", callback=button1_action)
    add_button(box, button_path, text="2", callback=button2_action)
    add_button(box, button_path, text="3", callback=button3_action)
    add_button(box, button_path, text="4", callback=button4_action)
    add_button(box, button_path, text="5", callback=button5_action)
    add_button(box, button_path, text="6", callback=button6_action)
    add_button(box, button_path, text="7", callback=button7_action)
    insert_button(box, button_path, text="8", callback=button8_action, index=0)

    def activate_changed(old_widget, new_widget, step):
        print 'old active: %r, new active: %r, step: %s' % (old_widget,
                                                            new_widget, step)

    box.active_changed.connect(activate_changed)
    
    def key_pressed(event):
        if event.keyval == pgmrender.KEY_q:
            reactor.stop()

    win.sig_key_press_event.connect(box.key_pressed)
    
    
    _background_widget = rectangle.Rectangle((800,600))
    _background_widget.ordering = widget.FAR
    img = image.Image('elisa/core/plugins/skins/default/pictures/background.png')
    _background_widget.media = img
    _background_widget.tz = -1
    win.add(_background_widget)
    
    win.add(box)
    x = (win.width - box.width) / 2.
    y = (win.height - box.height) / 2.
    box.position = (x, 0)

    win.sig_exit_event.connect(exit_event_cb)
    win.sig_key_press_event.connect(key_pressed)
    gobject.timeout_add(15, win.update)

    win.main(reactor.loop)
    
    reactor.run()
