# -*- coding: utf-8 -*-
# Elisa - Home multimedia server
# Copyright (C) 2006,2007 Fluendo Embedded S.L. (www.fluendo.com).
# All rights reserved.
#
# This file is available under one of two license agreements.
#
# This file is licensed under the GPL version 2.
# See "LICENSE.GPL" in the root of this distribution including a special
# exception to use Elisa with Fluendo's plugins.
#
# The GPL part of Elisa is also available under a commercial licensing
# agreement from Fluendo.
# See "LICENSE.Elisa" in the root directory of this distribution package
# for details on that license.

from elisa.core import media_uri
from elisa.core import common, log
from elisa.core.utils import misc
from elisa.core import plugin
from elisa.core import interfaces

from pgm.form import image as pgm_image

import os, sys

class Image(pgm_image.Image):
    """
    """

    data_access = plugin.ExtensionPoint(interfaces.IDataAccess)

    def __init__(self, uri=None, data=None, pixels=None, size=None,
                 format=None):
        if uri:
            # FIXME: should go away with uri mess cleaning
            if not isinstance(uri, media_uri.Uri):
                uri = media_uri.Uri(misc.fs_decode(uri))
            
            data_access_plugin = self.data_access.get("uri:%s" % uri.scheme)

            if not data_access_plugin:
                import pdb; pdb.set_trace()
                
            # FIXME: catch exception!
            handle = data_access_plugin.open(str(uri))
            data = handle.read()
            data_access_plugin.close(handle)

            pgm_image.Image.__init__(self, data=data)

        else:
            pgm_image.Image.__init__(self, data=data, pixels=pixels,
                                     size=size, format=format)
