# -*- coding: utf-8 -*-
# Elisa - Home multimedia server
# Copyright (C) 2006,2007 Fluendo Embedded S.L. (www.fluendo.com).
# All rights reserved.
#
# This file is available under one of two license agreements.
#
# This file is licensed under the GPL version 2.
# See "LICENSE.GPL" in the root of this distribution including a special
# exception to use Elisa with Fluendo's plugins.
#
# The GPL part of Elisa is also available under a commercial licensing
# agreement from Fluendo.
# See "LICENSE.Elisa" in the root directory of this distribution package
# for details on that license.

import sys
from totem import plparser

class PlaylistParser:

    def __init__(self):
        self.plparser = plparser.Parser()

    def parse(self, playlist_uri):
        items = []
        self.plparser.connect('entry', self.got_entry, items)
        self.plparser.parse(playlist_uri, False)
        return items
        
    def got_entry(self, parser, entry, title, genre, items):
        items.append(entry)


if __name__ == '__main__':

    p = PlaylistParser()
    
    print p.parse(sys.argv[-1])
